%global gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gemname rdiscount
%global geminstdir %{gemdir}/gems/%{gemname}-%{version}
%global ruby_sitearch %(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")

Summary: Discount (For Ruby). A Fast Implementation of Gruber's Markdown in C
Name: rubygem-%{gemname}
Version: 1.6.8
Release: 1%{?dist}
Group: Development/Languages
License: ASL 2.0
URL: https://github.com/rtomayko/rdiscount
Source0: http://rubygems.org/gems/%{gemname}-%{version}.gem
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: ruby(abi) = 1.8
Requires: rubygems
BuildRequires: rubygems
BuildRequires: ruby-devel
BuildRequires: rubygem(rake)
Provides: rubygem(%{gemname}) = %{version}

%description
Discount (For Ruby) Implementation of John Gruber's Markdown markup languange in C. It implements all of the language described in the markdown syntax document and passes the Markdown 1.0 test suite.

Requires: %{name} = %{version}-%{release}

%prep
%setup -q -T -c

%build
mkdir -p ./%{gemdir}
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
gem install --local --install-dir ./%{gemdir} -V --force --rdoc %{SOURCE0}

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{gemdir}
mkdir -p %{buildroot}/%{_bindir}
mkdir -p %{buildroot}/%{ruby_sitearch}

cp -a ./%{gemdir}/* %{buildroot}%{gemdir}
mv %{buildroot}%{geminstdir}/lib/*.so %{buildroot}%{ruby_sitearch}
mv %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_bindir}

# Shebang
for f in $(find %{buildroot}%{geminstdir} -name \*.rb) ; do
  sed -i -e '/^#!/d' $f
  chmod 0644 $f
done

# cleanups
find %{buildroot}%{geminstdir}/bin -type f | xargs chmod a+x
rm -rf %{buildroot}%{geminstdir}/test
rm -f %{buildroot}%{geminstdir}/Rakefile

%clean
rm -rf %{buildroot}

%check

%files
%defattr(-, root, root, -)
%dir %{geminstdir}
%_bindir/%{gemname}
%{gemdir}/bin
%{geminstdir}/bin
%{geminstdir}/lib
%{geminstdir}/ext
%{ruby_sitearch}/%{gemname}.so
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/gems/%{gemname}-%{version}/%{gemname}.gemspec
%{gemdir}/specifications/%{gemname}-%{version}.gemspec
%doc %{gemdir}/doc/%{gemname}-%{version}
%doc %{geminstdir}/man
%doc %{geminstdir}/[A-Z]*

%changelog
* Fri May 11 2012 <moses@puppetlabs.com> - 1.6.8-1
- Initial packaging
